## WnckClassGroup WnckClassGroup — an object representing a group of windows of the same class. |

## Stability Level

Unstable, unless otherwise indicated

## Functions

WnckClassGroup * | wnck_class_group_get ()
const char * | wnck_class_group_get_id ()
const char * | wnck_class_group_get_res_class ()
const char * | wnck_class_group_get_name ()
GdkPixbuf * | wnck_class_group_get_icon ()
GdkPixbuf * | wnck_class_group_get_mini_icon ()
GList * | wnck_class_group_get_windows ()

## Signals

void | icon-changed | Run Last
void | name-changed | Run Last

## Types and Values

| WnckClassGroup

## Object Hierarchy

        GObject
        ╰── WnckClassGroup

## Includes

    #include <libwnck/libwnck.h>

## Description

The WnckClassGroup is a group of WnckWindow that are all in the same class. It can be used to represent windows by classes, group windows by classes or to manipulate all windows of a particular class.

The class of a window is defined by the WM_CLASS property of this window. More information about the WM_CLASS property is available in the WM_CLASS Property section (section 4.1.2.5) of the ICCCM.

The WnckClassGroup objects are always owned by libwnck and must not be referenced or unreferenced.

## Functions

### wnck_class_group_get ()

    WnckClassGroup *
    wnck_class_group_get (const char *id);

Gets the WnckClassGroup corresponding to `id` .

#### Parameters

id | identifier name of the sought resource class. |

#### Returns

the WnckClassGroup corresponding to `id` , or `NULL` if there is no WnckClassGroup with the specified `id` . The returned WnckClassGroup is owned by libwnck and must not be referenced or unreferenced.

[transfer none]

Since: 2.2

### wnck_class_group_get_id ()

    const char *
    wnck_class_group_get_id (WnckClassGroup *class_group);

Gets the identifier name for `class_group` . This is the resource class for `class_group` .

#### Parameters

class_group | a WnckClassGroup. |

#### Returns

the identifier name of `class_group` , or an empty string if the group has no identifier name.

Since: 3.2

### wnck_class_group_get_res_class ()

    const char *
    wnck_class_group_get_res_class (WnckClassGroup *class_group);

`wnck_class_group_get_res_class` has been deprecated since version 3.2 and should not be used in newly-written code.

Use `wnck_class_group_get_id()` instead.

Gets the resource class name for `class_group` .

#### Parameters

class_group | a WnckClassGroup. |

#### Returns

the resource class name of `class_group` , or an empty string if the group has no resource class name.

Since: 2.2

### wnck_class_group_get_name ()

    const char *
    wnck_class_group_get_name (WnckClassGroup *class_group);

Gets an human-readable name for `class_group` . Since there is no way to properly find this name, a suboptimal heuristic is used to find it. The name is the name of all WnckApplication for each WnckWindow in `class_group` if they all have the same name. If all WnckApplication don't have the same name, the name is the name of all WnckWindow in `class_group` if they all have the same name. If all WnckWindow don't have the same name, the resource class name is used.

#### Parameters

class_group | a WnckClassGroup. |

#### Returns

an human-readable name for `class_group` .

Since: 2.2

### wnck_class_group_get_icon ()

    GdkPixbuf *
    wnck_class_group_get_icon (WnckClassGroup *class_group);

Gets the icon to be used for `class_group` . Since there is no way to properly find the icon, a suboptimal heuristic is used to find it. The icon is the first icon found by looking at all the WnckApplication for each WnckWindow in `class_group` , then at all the WnckWindow in `class_group` . If no icon was found, a fallback icon is used.

#### Parameters

class_group | a WnckClassGroup. |

#### Returns

the icon for `class_group` . The caller should reference the returned `GdkPixbuf` if it needs to keep the icon around.

[transfer none]

Since: 2.2

### wnck_class_group_get_mini_icon ()

    GdkPixbuf *
    wnck_class_group_get_mini_icon (WnckClassGroup *class_group);

Gets the mini-icon to be used for `class_group` . Since there is no way to properly find the mini-icon, the same suboptimal heuristic as the one for `wnck_class_group_get_icon()` is used to find it.

#### Parameters

class_group | a WnckClassGroup. |

#### Returns

the mini-icon for `class_group` . The caller should reference the returned `GdkPixbuf` if it needs to keep the mini-icon around.

[transfer none]

Since: 2.2

### wnck_class_group_get_windows ()

    GList *
    wnck_class_group_get_windows (WnckClassGroup *class_group);

Gets the list of WnckWindow that are grouped in `class_group` .

#### Parameters

class_group | a WnckClassGroup. |

#### Returns

the list of WnckWindow grouped in `class_group` , or `NULL` if the group contains no window. The list should not be modified nor freed, as it is owned by `class_group` .

[element-type WnckWindow][transfer none]

Since: 2.2

## Types and Values

### WnckClassGroup

    typedef struct _WnckClassGroup WnckClassGroup;

The WnckClassGroup struct contains only private fields and should not be directly accessed.

## Signal Details

### The `“icon-changed”` signal

    void
    user_function (WnckClassGroup *class_group,
                   gpointer        user_data)

Emitted when the icon of `class_group` changes.

#### Parameters

class_group | the WnckClassGroup which emitted the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“name-changed”` signal

    void
    user_function (WnckClassGroup *class_group,
                   gpointer        user_data)

Emitted when the name of `class_group` changes.

#### Parameters

class_group | the WnckClassGroup which emitted the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

## See Also

wnck_window_get_class_group()